<template>
  <!--动画-->
  <transition name="el-fade-in">
    <el-dialog
      :title="title"
      :width="width"
      :modal="false"
      :visible.sync="visible"
      top="150px"
      :append-to-body="false"
      :destroy-on-close="true"
      @close="close"
    >
      <div v-loading="loading">
        <slot/>
      </div>
      <div v-if="$slots.footer" slot="footer">
        <slot name="footer"/>
      </div>
    </el-dialog>
  </transition>
</template>

<script>
export default {
  props: {
    loading: {
      type: Boolean,
      default: false
    },
    title: {
      type: String,
      default: ''
    },
    width: {
      type: String,
      default: '50%'
    }
  },
  data() {
    return {
      visible: true
    }
  },
  mounted() {
    try {
      window.onresize = function () {
        document.querySelectorAll('.cus-dialog').forEach(v => {
          v.style.width = document.querySelector('.app-main').clientWidth + 'px'
          v.style.height = '100%'
        })
      }
      window.onresize()
    } catch (e) {
      console.error(e)
    }
  },
  methods: {
    close() {
      this.visible = false
      this.$emit('close')
    }
  }
}
</script>

<style scoped>
>>> .el-dialog__body {
  overflow-y: auto;
  max-height: calc(100vh - 140px);
}
</style>
